import events
from charactor import MarbleFactory

class Player:
	def __init__(self):
		self.MAXPIECES = 6
		self.factory = None
		self.gamePieces = []

	def Start(self):
		events.AddListener(self)

	def On_LevelStartedEvent(self):
		self.factory = MarbleFactory()
		events.Fire("MarbleFactoryBirth", self.factory, self )

	def On_GamePieceBirth( self, piece ):
		self.gamePieces.append( piece )
		if len(self.gamePieces) >= self.MAXPIECES:
			self.factory.StopProduction()

	def On_GamePieceDeath( self, piece ):
		if piece not in self.gamePieces:
			return
		self.gamePieces.remove( piece )
		self.factory.StartProduction()
