#! /usr/bin/python

import pygame
import math

DEBUG = 1

def TransSurface( w,h ):
	return pygame.Surface( (w,h), pygame.SRCALPHA, 32 )


def HalfwayBetween( a, b ):
	distanceX, distanceY = VectorSubtract( b, a )
	x = a[0] + distanceX/2
	y = a[1] + distanceY/2
	return (x,y)

def Distance( a, b ):
	distanceX, distanceY = VectorSubtract( b, a )
	return math.sqrt( distanceX**2 + distanceY**2 )
	
def Clamp( value, floor, ceiling ):
	return min( ceiling, max( floor, value ) )

def VectorAdd( a, b ):
	return a[0]+b[0], a[1]+b[1]

def VectorSubtract( a, b ):
	return a[0]-b[0], a[1]-b[1]

def VectorMultiply( a, b ):
	return a[0]*b[0], a[1]*b[1]

def GetAngle( a, b=(0,0) ):
	'''get the angle in radians'''
	top = a[1]-b[1]
	divisor = ( a[0]-b[0] )
	if a[0] < b[0]:
		add = math.pi
	else:
		add = 0
	if divisor == 0:
		if top > 0:
			return math.acos(0)
		else:
			return -math.acos(0)
	return math.atan( float(top) / divisor ) + add

def GetPosAtAngleFrom( point, angle, distance ):
	unitX = math.cos( angle ) * distance
	unitY = math.sin( angle ) * distance
	return VectorAdd( (unitX, unitY), point )

def NormalizeAngle( angle ):
	return angle % (2*math.pi)
